//#define REALTIME
/* ^^^^ uncomment this line if you wanna try REALTIME PLAYING!!! */
#include "modBox.h"

#ifdef REALTIME
#ifdef BROKEN_SCHED
#include <linux/sched.h>
#else
#include <sched.h>
#endif
#endif

modBox::modBox()
{
        int alto_barra = 26;

        setCaption("K ModBox");
	setFixedSize(465,340);

	QString dir;
        dir=KApplication::getKApplication()->kde_datadir();
        dir+="/kmodbox/pixs/";
		
	archivos = new QListView(this, "archivos");
        archivos->setGeometry(8,24+alto_barra,202,274);
	archivos->setFrameStyle(QFrame::Sunken | QFrame::WinPanel);
        archivos->addColumn(i18n("Name"), 129);
        archivos->addColumn(i18n("Size"), -1); //47);
        archivos->setColumnAlignment(1,2);
        archivos->setAllColumnsShowFocus(true);
        archivos->setSorting(-1);
        QHeader *the_header=archivos->header();
        the_header->setClickEnabled(false,-1);
	
	timer = new QTimer(this, "timer");
	
	label_titulo = new QLabel(this, "label_titulo");
	label_titulo->setText("El titulo del MOD g");
	label_titulo->setAlignment(AlignLeft | AlignVCenter);
	label_titulo->setFrameStyle(QFrame::Sunken | QFrame::WinPanel);
	label_titulo->setGeometry(218,24+alto_barra,245,19);
	
	camino = new QLabel(this, "camino");
	camino->setText("/home/root/usr/Mods");
	camino->setAlignment(AlignLeft | AlignVCenter);
	camino->setFrameStyle(QFrame::NoFrame | QFrame::NoFrame);
	camino->setGeometry(8,300+alto_barra,443,15);
	
	instrumentos = new QListBox(this, "instrumentos");
	instrumentos->setAutoScrollBar((bool)1);
	instrumentos->setMultiSelection((bool)0);
	instrumentos->setAutoBottomScrollBar((bool)1);
	instrumentos->setDragSelect((bool)1);
	instrumentos->setBottomScrollBar((bool)0);
	instrumentos->setScrollBar((bool)0);
	instrumentos->setGeometry(219,90+alto_barra,215,155);
	instrumentos->setFont(QFont("courier",12,QFont::Normal,(int)0));
	
	label2 = new QLabel(this, "label2");
	label2->setText(i18n("File browser:"));
	label2->setAlignment(AlignLeft | AlignTop);
	label2->setFrameStyle(QFrame::NoFrame | QFrame::NoFrame);
	label2->setGeometry(8,8+alto_barra,100,14);
	
	labeltitulo = new QLabel(this, "labeltitulo");
	labeltitulo->setText(i18n("Title:"));
	labeltitulo->setAlignment(AlignLeft | AlignTop);
	labeltitulo->setFrameStyle(QFrame::NoFrame | QFrame::NoFrame);
	labeltitulo->setGeometry(217,7+alto_barra,233,15);

        labelTipo = new QLabel(this, "labelTipo");
        labelTipo->setAlignment(AlignLeft | AlignTop);
        labelTipo->setFrameStyle(QFrame::NoFrame | QFrame::NoFrame);
        labelTipo->setGeometry(355,43+alto_barra,105,15);

        labelCanales = new QLabel(this, "labelCanales");
        labelCanales->setAlignment(AlignLeft | AlignTop);
        labelCanales->setFrameStyle(QFrame::NoFrame | QFrame::NoFrame);
        labelCanales->setGeometry(355,58+alto_barra,100,15);

	lcd_pattern = new clasePattern(this, "lcd_pattern");
        lcd_pattern->setGeometry(218,47+alto_barra,65,25);
        QToolTip::add(lcd_pattern,"Patterns");
	
	lcd_tiempo = new claseTiempo(this, "lcd_tiempo");
        lcd_tiempo->setGeometry(287,47+alto_barra,65,25);
        QToolTip::add(lcd_tiempo,i18n("Time"));

        slider_tiempo = new claseSliderTiempo(this, "slider_tiempo");

	label1 = new QLabel(this, "label1");
	label1->setText(i18n("Instruments list:"));
	label1->setAlignment(AlignLeft | AlignTop);
	label1->setFrameStyle(QFrame::NoFrame | QFrame::NoFrame);
	label1->setGeometry(218,73+alto_barra,120,15);
	
	slide_volumen = new claseVolumen(this, "slide_volumen");
	
	previa = new QPushButton(this, "previa");
	previa->setPixmap(*new QPixmap(dir+"previa.xpm"));
	previa->setDefault((bool)0);
	previa->setToggleButton((bool)0);
	previa->setAutoResize((bool)0);
	previa->setGeometry(223,278+alto_barra,30,20);
	QToolTip::add(previa,i18n("previous MOD"));
	
	retroceder = new QPushButton(this, "retroceder");
	retroceder->setPixmap(*new QPixmap(dir+"retroceder.xpm"));
        retroceder->setDefault((bool)0);
	retroceder->setToggleButton((bool)0);
	retroceder->setAutoResize((bool)0);
	retroceder->setGeometry(253,278+alto_barra,30,20);
	QToolTip::add(retroceder,i18n("Back"));
	
	tocar = new QPushButton(this, "tocar");
	tocar->setPixmap(*new QPixmap(dir+"tocar.xpm"));
	tocar->setDefault((bool)0);
	tocar->setToggleButton((bool)0);
	tocar->setAutoResize((bool)0);
	tocar->setGeometry(283,278+alto_barra,30,20);
	QToolTip::add(tocar,i18n("Play/Pause"));
	
	avanzar = new QPushButton(this, "avanzar");
	avanzar->setPixmap(*new QPixmap(dir+"avanzar.xpm"));
	avanzar->setDefault((bool)0);
	avanzar->setToggleButton((bool)0);
	avanzar->setAutoResize((bool)0);
	avanzar->setGeometry(313,278+alto_barra,30,20);
	QToolTip::add(avanzar,i18n("Forward"));
	
	siguiente = new QPushButton(this, "siguiente");
	siguiente->setPixmap(*new QPixmap(dir+"siguiente.xpm"));
	siguiente->setDefault((bool)0);
	siguiente->setToggleButton((bool)0);
	siguiente->setAutoResize((bool)0);
	siguiente->setGeometry(343,278+alto_barra,30,20);
	QToolTip::add(siguiente,i18n("next MOD"));
	
	parar = new QPushButton(this, "parar");
	parar->setPixmap(*new QPixmap(dir+"parar.xpm"));
	parar->setDefault((bool)0);
	parar->setToggleButton((bool)0);
	parar->setAutoResize((bool)0);
	parar->setGeometry(373,278+alto_barra,30,20);
	QToolTip::add(parar,i18n("Stop"));
	
	boton_config = new QPushButton(this, "boton_config");
	boton_config->setPixmap(*new QPixmap(dir+"configurar.xpm"));
	boton_config->setDefault((bool)0);
	boton_config->setToggleButton((bool)0);
	boton_config->setAutoResize((bool)0);
	boton_config->setGeometry(418,278+alto_barra,30,20);
	QToolTip::add(boton_config,i18n("Setup"));

	lcd_volumen = new claseLcdVolumen(this, "lcd_volumen");
	
        barra = new KToolBar(this,"barra");
        barra->enableMoving( FALSE );

        barra->insertButton( *new QPixmap(dir+"arriba.xpm"), BOTON_CDPP,
                             SIGNAL(clicked()), this,
                             SLOT(subir_directorio()), TRUE,
                             "cd ..");	

        barra->insertButton( *new QPixmap(dir+"home.xpm"), BOTON_HOME,
                             SIGNAL(clicked()), this,
                             SLOT(click_home()), TRUE,
                             i18n("Initial directory"));

        barra->insertButton( *new QPixmap(dir+"guardar.xpm"), BOTON_GUARDAR,
                             SIGNAL(clicked()), this,
                             SLOT(click_guardar()), TRUE,
                             i18n("Check this directory as the initial directory"));

        barra->insertButton( *new QPixmap(dir+"todos.xpm"), BOTON_TODOS,
                             SIGNAL(toggled(bool)), this,
                             SLOT(mostrar_todos(bool)), TRUE,
                             i18n("Show all files"));
        barra->setToggle(BOTON_TODOS,TRUE);
        barra->insertSeparator(-1);

        barra->insertButton( *new QPixmap(dir+"inst.xpm"), BOTON_INS,
                             SIGNAL(toggled(bool)), this,
                             SLOT(actualizar_ins(bool)), TRUE,
                             i18n("Samples info"));
        barra->setToggle(BOTON_INS,TRUE);
        barra->setItemEnabled(BOTON_INS,FALSE);

        barra->insertButton( *new QPixmap(dir+"texto.xpm"), BOTON_TEXTO,
                             SIGNAL(toggled(bool)), this,
                             SLOT(actualizar_texto(bool)), TRUE,
                             i18n(".it TextViewer"));
        barra->setToggle(BOTON_TEXTO,TRUE);
        barra->setItemEnabled(BOTON_TEXTO,FALSE);

        barra->insertButton( *new QPixmap(dir+"ayuda.xpm"), BOTON_AYUDA,
                             SIGNAL(clicked()), this,
                             SLOT(click_ayuda()), TRUE,
                             i18n("Help"));
/*   	ayuda->setGeometry(415,50+alto_barra,25,25); */

        barra->insertButton( *new QPixmap(dir+"logo.xpm"), BOTON_ACERCADE,
                             SIGNAL(clicked()), this,
                             SLOT(acerca_de()), TRUE,
                             i18n("About..."));

	QObject::connect(boton_config,SIGNAL(clicked()),
		this,SLOT(click_config()));
	QObject::connect(parar,SIGNAL(clicked()),
		this,SLOT(parar_modulo()));
	QObject::connect(siguiente,SIGNAL(clicked()),
		this,SLOT(click_siguiente()));
	QObject::connect(avanzar,SIGNAL(clicked()),
		this,SLOT(click_avanzar()));
	QObject::connect(tocar,SIGNAL(clicked()),
		this,SLOT(click_tocar()));
	QObject::connect(retroceder,SIGNAL(clicked()),
		this,SLOT(click_retroceder()));
	QObject::connect(previa,SIGNAL(clicked()),
		this,SLOT(click_previa()));
	QObject::connect(slide_volumen,SIGNAL(valueChanged(int)),
		this,SLOT(cambiar_volumen(int)));
	QObject::connect(timer,SIGNAL(timeout()),
		this,SLOT(actualizar_sonido()));
	QObject::connect(archivos,SIGNAL(doubleClicked(QListViewItem*)),
		this,SLOT(seleccionado(QListViewItem*)));
	QObject::connect(archivos,SIGNAL(selectionChanged(QListViewItem*)),
		this,SLOT(cambio_seleccion(QListViewItem*)));
       	QObject::connect(slider_tiempo,SIGNAL(valueChanged(int)),
                this,SLOT(cambiar_pattern(int)));

        /* Agregar la barra de botones */
        addToolBar(barra);

        config=kapp->getConfig();
	/* Instanciar clases */
	directorio=new QDir;
	reloj=new QTime;
	boton_tocar  = new QPixmap(dir+"tocar.xpm",0,0);
	boton_pausa  = new QPixmap(dir+"pausa.xpm",0,0);
	imagen_dir   = new QPixmap(dir+"dir.xpm",0,0);
	imagen_arch  = new QPixmap(dir+"mini-kmodbox.xpm",0,0);
        imagen_todos = new QPixmap(dir+"exclam.xpm",0,0);

	/* Inicializaciones varias */
	cambio_sel=FALSE;
	config->setGroup("general");
	actualizar_archivos(config->readEntry("directory"));
	slide_volumen->setValue(0);
	modulo=NULL;
	volumen_ant=10;
	pattern_ant=10;
	estado=ENNADA;
        no_avanzar=FALSE;
	
	/* inicializar los displays */
	lcd_pattern->display("00-00");
	lcd_tiempo->display("00:00");
	label_titulo->setText("");
	
	/* inicializar la libreria de sonido */
	inicializar_sonido();
        cambiar_volumen(0);
}

modBox::~modBox()
{
}

void modBox::cambiar_volumen(int vol)
{
        volumen=(MAX_VOL - vol) * MAX_VOL_MOD / 100;
	if (volumen!=volumen_ant)
	{
		volumen_ant=volumen;
		lcd_volumen->display(MAX_VOL - vol - 1);
		Player_SetVolume(volumen);
	}
}

void modBox::actualizar_tiempo()
{
	int seg, min;
	
	seg=reloj->elapsed();
	if (estado==TOCANDO)
	{
		seg = (seg - tiempo_pausa) / 1000;
		if ( seg != reloj_ant )
		{
			min=seg / 60;
			seg=seg % 60;
			aux.sprintf("%2d:%2d",min,seg);
			if (aux[0]==' ') aux[0]='0';
			if (aux[3]==' ') aux[3]='0';
			reloj_ant=seg;
			lcd_tiempo->display(aux);
		}
	}
}

void modBox::actualizar_pattern()
{
	SWORD pattern_act, n;
	
	pattern_act=modulo->sngpos;
	n=modulo->patpos;
	if (pattern_act != pattern_ant)
	{
            if (pattern_act<modulo->numpos)
            {
		pattern_ant=pattern_act;
		aux.sprintf("%2d-%2d", pattern_act+1, modulo->numpos);
		lcd_pattern->display(aux);
                no_avanzar=TRUE;
                slider_tiempo->setValue(pattern_act);
                no_avanzar=FALSE;
            }
	}
}

void modBox::actualizar_archivos(const char *dir)
{
	int c;
        QFileInfo *fi;
        const QFileInfoList *lista;
        QFileInfoListIterator *it;
        QString s;
        QListViewItem *item;
        /*         ><      */
	char tipos[29][16] = { "*.669", "*.dsm", "*.DSM", "*.far", "*.FAR",
	                       "*.it", "*.IT", "*.med", "*.MED",
	                       "*.mod", "*.MOD", "mod.*", "MOD.*",
	                       "*.mtm", "*.MTM",
                               "*.s3m", "*.S3M", "s3m.*", "S3M.*",
	                       "*.stm", "*.STM", "*.ult", "*.ULT",
	                       "*.ust", "*.UST",
	                       "*.xm", "*.XM", "xm.*", "XM.*" };
	
	if (directorio->cd(dir,TRUE))
	/* agregar archivos a la listbox */
	{
		/* borrar la lista anterior */
//		archivos->setAutoUpdate( FALSE );
		archivos->clear();
	
		directorio->setSorting( QDir::Name );
	
		/* Primero agregar los directorios */
		directorio->setFilter( QDir::Dirs | QDir::Hidden );
		directorio->setNameFilter("*");
                lista=directorio->entryInfoList();
                it=new QFileInfoListIterator( *lista);
                item=NULL;
                while ( (fi=it->current()) )
		{
                    item = new QListViewItem( archivos, item, fi->fileName(), "");
                    item->setPixmap(0,(*imagen_dir));
                    ++(*it);
		}
                delete it;
	
                if (barra->isButtonOn(BOTON_TODOS))
                {
                    /* mostrar todos los archivos */
    	            directorio->setFilter( QDir::Files | QDir::Hidden );
                    directorio->setNameFilter("*");
                    if (directorio->count() > 0)
                    {
                        lista=directorio->entryInfoList();
                        it=new QFileInfoListIterator( *lista);
                        while ( (fi=it->current()) )
                        {
                            s.setNum( fi->size() );
                            item = new QListViewItem( archivos, item, fi->fileName(), s);
                            item->setPixmap(0,(*imagen_todos));
                            ++(*it);
                        }
                        delete it;
                    }
                }
                else
                {
                    /* Ahora los archivos asociados a K ModBox */
        	    directorio->setFilter( QDir::Files | QDir::Hidden );
        	    for (c=0;c<29;c++)
        	    {
        		directorio->setNameFilter(tipos[c]);
                        if (directorio->count() > 0)
                        {
                            lista=directorio->entryInfoList();
                            it=new QFileInfoListIterator( *lista);
                            while ( (fi=it->current()) )
                            {
                                s.setNum( fi->size() );
                                item = new QListViewItem( archivos, item, fi->fileName(), s);
                                item->setPixmap(0,(*imagen_arch));
                                ++(*it);
                            }
                            delete it;
                        }
        	    }
                }

		/* actualizar la pantalla */
//		archivos->setAutoUpdate( TRUE );
//		archivos->repaint();
                archivos->setSelected( archivos->firstChild(), true );
		camino->setText( directorio->absPath() );
	}	
}

void modBox::seleccionado(QListViewItem *x)
{
    QString s;

    s=x->text(1);
    if ( s.isEmpty() )
    {
    	actualizar_archivos( x->text(0) );
    }
    else
    {
    	/* seleccionar un nuevo mod */
    	s=directorio->absPath();
    	s+='/';
    	s+=x->text(0);
    	nuevo_mod(s);
    }
}

void modBox::subir_directorio()
{
	actualizar_archivos("..");
}

int modBox::inicializar_sonido()
{
#ifdef REALTIME
        /* Realtime Priority! */
        struct sched_param sp;
        memset(&sp, 0, sizeof(struct sched_param));
        sp.sched_priority = 1;
        if (sched_setscheduler(0, SCHED_RR, &sp) == -1)
	   perror("realtime priority");
#endif

        /* configuraciones por defecto */
        md_device       = 0;                /* standard device: autodetect */
        md_volume       = 128;              /* driver volume (max 128) 96 */
        md_musicvolume  = 128;              /* music volume (max 128) */
        md_sndfxvolume  = 128;              /* sound effects volume (max 128) */
        md_pansep       = 128;              /* panning separation (0 = mono, 128 = full stereo) */
/*      md_stereodelay  = 10;               // Stereo Delay (max 15) */

        config->setGroup("sound");

        md_reverb = config->readNumEntry("reverb");               /* Reverb (max 15) */

        md_mode = DMODE_SOFT_MUSIC;  /* default mixing mode */
	if ( config->readBoolEntry("stereo") )   md_mode |= DMODE_STEREO;
        if ( config->readBoolEntry("reverse") )  md_mode |= DMODE_REVERSE;
        if ( config->readBoolEntry("16bits") )   md_mode |= DMODE_16BITS;
	if ( config->readBoolEntry("filter") )   md_mode |= DMODE_INTERP;
        if ( config->readBoolEntry("surround") ) md_mode |= DMODE_SURROUND;
	
        md_pansep = config->readNumEntry("separation") * 8; // panning separation (0 = mono, 128 = full stereo)
        md_mixfreq = config->readNumEntry("frequency");

	/* Register the loaders we want to use..  */
	MikMod_RegisterAllLoaders();

	/* Register the drivers we want to use: */
	MikMod_RegisterAllDrivers();

	BOOL rc;
	if ( (rc=MikMod_Init())==true )
	{
                QMessageBox::information(this,i18n("K ModBox ERROR!"),
                                         "MikMod_Init()");
		kapp->quit();
	}

        return 0;
}

void modBox::nuevo_mod( const char *nombre )
{
        char *cad;
	
	if (modulo != NULL)
	/* vaciar el modulo anterior */
	{
                if (Player_Active())
			Player_Stop();
		Player_Free(modulo);
	}
	
	/* cargar el archivo */
	cad=qstrdup(nombre);
        if((modulo=Player_Load(cad,255,0)) == NULL)
	{
                QMessageBox::information(this,i18n("K ModBox ERROR!"),
                                         "Player_Load()");
		exit(1);
	}
	
	/* mostrar informacion del modulo */
	info_modulo();

        /* algunas inicializaciones */
        modulo->extspd  = 1;
        modulo->panflag = 1;
        modulo->loop    = config->readBoolEntry("repeat");
        no_avanzar=FALSE;
        /* para que se muestre si o si el pattern */
        pattern_ant=10;
        slider_tiempo->setValue(0);
	slider_tiempo->setRange(0,(modulo->numpos)-1);
        /* Si tiene comentarios... */
        if (modulo->comment != NULL )
        {
                barra->setItemEnabled(BOTON_TEXTO,TRUE);
                emit cambiar_texto( modulo->comment );
        }
        else
        {
            /* Ocultar la ventana de texto */
            emit mostrar_texto( FALSE );
            barra->setButton(BOTON_TEXTO, FALSE);
            barra->setItemEnabled(BOTON_TEXTO,FALSE);
        }
        /* Cargar y mostrar informacin de instrumentos */
        barra->setItemEnabled(BOTON_INS,TRUE);
        emit cambiar_ins( modulo );
        // emit cambiar_ins( modulo );

	/* ... y ejecutar */
	Player_Start(modulo);
        Player_SetVolume(volumen);
	estado=TOCANDO;
	tocar->setPixmap( (*boton_pausa) );
	cambio_sel=FALSE;
	tiempo_pausa=0;
	inicio_pausa=0;
	
	/* lanzar el timer */
	reloj_ant=99;
	reloj->start();
	timer->start(100,FALSE);
}

void modBox::actualizar_sonido()
{
        if (Player_Active())
        {
        /* seguir tocando el modulo */
	    MikMod_Update();
	    actualizar_pattern();
	    actualizar_tiempo();
        }
        else
        {
            if (estado!=RESETEANDO)
            {
               click_siguiente();
            }
        }
}

void modBox::parar_modulo()
{
        QString s;

	if ( (estado==TOCANDO) || (estado==ENPAUSA) )
	{
                Player_SetPosition(0);
		Player_Stop();
		timer->stop();
		estado=PARADO;
                slider_tiempo->setValue(0);
		tocar->setPixmap( (*boton_tocar) );
		lcd_tiempo->display("00:00");
		s.sprintf(" 0-%2d", modulo->numpos);
		lcd_pattern->display(s);
	}
}

void modBox::click_tocar()
{
        if (cambio_sel==TRUE)
	{
		seleccionado( archivos->currentItem() );
	}
	else
	{
		switch(estado)
		{
			case ENPAUSA:   estado = TOCANDO;
			                Player_TogglePause();
                                        if (slider_tiempo->value() != modulo->sngpos)
                                           cambiar_pattern(slider_tiempo->value());
					tiempo_pausa=reloj->elapsed() - inicio_pausa;
					tocar->setPixmap( (*boton_pausa) );
					break;
			case TOCANDO:	Player_TogglePause();
					tocar->setPixmap( (*boton_tocar) );
					estado = ENPAUSA;
					inicio_pausa=reloj->elapsed();
					break;
			case PARADO:	Player_SetPosition( 0);
                                        slider_tiempo->setValue(0);
					tocar->setPixmap( (*boton_pausa) );
					Player_Start(modulo);
					estado = TOCANDO;
					reloj_ant=99;
					tiempo_pausa=0;
					inicio_pausa=0;
					reloj->restart();
					timer->start(100,FALSE);
					break;
			case ENNADA:	break;
		}
	}
}

void modBox::cambio_seleccion(QListViewItem *x)
{
    QString s;

    s=x->text(1);
    if ( !s.isEmpty() )
    {
        cambio_sel=TRUE;
        tocar->setPixmap( (*boton_tocar) );
    }
}

void modBox::click_siguiente()
{
    QListViewItem *actual;
    QString texto;

    actual=archivos->currentItem();
    texto=actual->text(1);
    if ( !texto.isEmpty() )
    /* it isn't a directory */
    {
        if ( actual->itemBelow() == NULL )
        /* is the last one */
        {
            actual = archivos->firstChild();
            texto = actual->text(1);
            while ( texto.isEmpty() )
            /* skip directories */
            {
               actual = actual->itemBelow();
               texto=actual->text(1);
            }
            archivos->setSelected( actual, true );
        }
        else
        {
            archivos->setSelected( actual->itemBelow(), true );
        }
        archivos->ensureItemVisible( archivos->currentItem() );
        seleccionado( archivos->currentItem() );
    }
}

void modBox::click_previa()
{
    QListViewItem *actual, *otro;
    QString texto;

    actual=archivos->currentItem();
    texto=actual->text(1);
    if ( !texto.isEmpty() )
    {
        otro = actual->itemAbove();
        texto= otro->text(1);
        if ( texto.isEmpty() )
        /* es el tope de la lista */
        {
            while (actual->itemBelow() != NULL)
                actual = actual->itemBelow();
            archivos->setSelected( actual, true );
        }
        else
        {
            archivos->setSelected( otro, true );
        }
        archivos->ensureItemVisible( archivos->currentItem() );
        seleccionado( archivos->currentItem() );
    }
}

void modBox::click_avanzar()
{
	if (estado==TOCANDO)
	{
		if (modulo->sngpos != (modulo->numpos -1) )
                        Player_NextPosition();
                else
                        Player_SetPosition(0);
                actualizar_pattern();
	}
}

void modBox::click_retroceder()
{
	if (estado==TOCANDO)
	{
		if (modulo->sngpos != 0)
                        Player_PrevPosition();
                actualizar_pattern();
	}
}

void modBox::info_modulo()
{
        SWORD patch;
	QString s;
        QListViewItem *item;
	
	/* titulo del MOD */
	label_titulo->setText(modulo->songname);
        /* tipo del mod */
        labelTipo->setText(modulo->modtype);
        /* nmero de canales */
        s.setNum(modulo->numchn);
        s.insert(0,i18n("Channels: "));
        labelCanales->setText(s);
        /* Barra de titulos */
        item=archivos->currentItem();
	s=item->text(0);
	s+=" - K ModBox";
	setCaption(s);
	
	/* cargar los mensajes de los instrumentos */
	instrumentos->setAutoUpdate( FALSE );
	instrumentos->clear();
        if (modulo->instruments!=NULL)
        /* Cargar texto de instrumentos (.XM) */
        {
            for (patch=0; patch<modulo->numins; patch++)
            {
                if (modulo->instruments[patch].insname!=NULL)
                    instrumentos->insertItem( modulo->instruments[patch].insname, -1);
                else
                    instrumentos->insertItem("",-1);
            }
        }
        /* Cargar texto de samples (.S3M) */
        else
        {
            for (patch=0; patch<modulo->numsmp; patch++)
            {
                if (modulo->samples[patch].samplename!=NULL)
                    instrumentos->insertItem( modulo->samples[patch].samplename, -1);
                else
                    instrumentos->insertItem("",-1);
            }
        }

	instrumentos->setAutoUpdate( TRUE );
	instrumentos->repaint();
}

void modBox::click_config()
{
	emit quiero_conf();
}

void modBox::acerca_de()
{
	QMessageBox::information(this,i18n("About..."),
                                 ("K ModBox v0.3.2\n"
                                  "(c) 1999 - Guillermo P. Marotte"));
}

/* Se activa al mover el slider del tiempo */
void modBox::cambiar_pattern(int pat)
{
	if (estado==TOCANDO && modulo!=NULL)
	{
                if (no_avanzar==FALSE) Player_SetPosition(pat);
	}
}

void modBox::click_ayuda()
{
        KApplication::getKApplication()->invokeHTMLHelp("kmodbox/doc.html","");
}

void modBox::actualizar_conf()
{
        bool need_reset = false;
        config->setGroup("sound");

        /* options that makes mikmod need to be reseted */
        int oldMode = DMODE_SOFT_MUSIC | (md_mode & DMODE_STEREO)
                                       | (md_mode & DMODE_16BITS)
                                       | (md_mode & DMODE_INTERP);
        md_mode = DMODE_SOFT_MUSIC;  /* default mixing mode */
	if ( config->readBoolEntry("stereo") ) md_mode |= DMODE_STEREO;
        if ( config->readBoolEntry("16bits") ) md_mode |= DMODE_16BITS;
	if ( config->readBoolEntry("filter") ) md_mode |= DMODE_INTERP;
        if ( oldMode != md_mode) need_reset = true;

        if (md_mixfreq != config->readNumEntry("frequency"))
        {
           md_mixfreq = config->readNumEntry("frequency");
           need_reset = true;
        }

        if (need_reset) reset_mikmod();
        /* end reset-options */

        md_pansep = config->readNumEntry("separation") * 8; // panning separation (0 = mono, 128 = full stereo)
        md_reverb = config->readNumEntry("reverb"); /* Reverb (max 15) */

        if ( config->readBoolEntry("reverse") )  md_mode |= DMODE_REVERSE;
        if ( config->readBoolEntry("surround") ) md_mode |= DMODE_SURROUND;

        config->setGroup("general");
        if (modulo!=NULL) modulo->loop=config->readBoolEntry("repeat");
}

void modBox::reset_mikmod()
{
        SWORD oldPos = 0;
        bool reload = false;
        int oldEstado = estado;

        estado = RESETEANDO;

        if ( modulo!=NULL)
        {
           oldPos=modulo->sngpos;
           Player_Stop();
           Player_Free(modulo);
           reload=true;
        }
        if (Player_Active())
           MikMod_DisableOutput();

	BOOL rc;
	if ( (rc=MikMod_Reset())==true )
	{
                QMessageBox::information(this,i18n("K ModBox ERROR!"),
                                         "MikMod_Reset()");
		kapp->quit();
	}
        MikMod_EnableOutput();

        if (reload)
        {
                QString s;
              	s=directorio->absPath();
          	s+='/';
          	s+=archivos->currentItem()->text(0);
                if((modulo=Player_Load(s,255,0)) == NULL)
        	{
                        QMessageBox::information(this,i18n("K ModBox ERROR!"),
                                                 "Player_Load()");
        		exit(1);
        	}
        }

        if (oldEstado==TOCANDO || oldEstado==ENPAUSA)
        {
           Player_Start(modulo);
           Player_SetVolume(volumen);
           Player_SetPosition(oldPos);
           if (oldEstado==ENPAUSA)
              Player_TogglePause();
        }
        estado = oldEstado;
}

void modBox::closeEvent( QCloseEvent *e )
{
        /* desinicializar! */
        parar_modulo();
        if ( modulo!=NULL)
        {
                Player_Free(modulo);
        }
        MikMod_Exit();

        config->sync();
        kapp->quit();
        e->accept();
}

void modBox::actualizar_texto( bool v)
{
        emit mostrar_texto( v );
}

void modBox::ocultar_texto()
{
        /* desactivar el boton del Texto */
        barra->setButton(BOTON_TEXTO, FALSE);
}

void modBox::actualizar_ins( bool v)
{
        emit mostrar_ins( v );
}

void modBox::ocultar_ins()
{
        /* desactivar el boton de Instrumentos */
        barra->setButton(BOTON_INS, FALSE);
}

void modBox::mostrar_todos( bool v )
{
        v=v; /* para no tener warnigns! */
        actualizar_archivos(".");
}

void modBox::click_home()
{
        config->setGroup("general");
	actualizar_archivos(config->readEntry("directory"));
}

void modBox::click_guardar()
/* guardar el dir actual como el de inicio */
{
        config->setGroup("general");
	config->writeEntry("directory", directorio->absPath() );
        config->sync();
}
#include "modBox.moc"